(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.highlight = factory());
}(this, (function () { 'use strict';

function encode(str, jsUnicode) {
	if ( jsUnicode === void 0 ) jsUnicode = true;

	var result = [];
	var len = str.length;
	for (var i = 0; i < len; i++) {
		var hex = str.charAt(i).charCodeAt(0).toString(16);
		if (jsUnicode) {
			result.push(("\\u" + (((("000" + hex)).slice(-4)))));
		} else {
			result.push(hex);
		}
	}
	return result.join('')
}

/* eslint max-depth: 0 */
function highlight(source, q, tpl, split) {
	if ( tpl === void 0 ) tpl = '<mark>$&</mark>';
	if ( split === void 0 ) split = true;

	var spade = '\u2664';
	var words = (split ? q.split(' ') : [q]).sort(function (a, b) { return b.length - a.length; });
	var map = {};
	var unique = {};
	var cc = 0;
	for (var i = 0; i < words.length; i++) {
		var word = words[i];
		if (word) {
			var matches = source.match(new RegExp(("(" + (encode(word)) + ")"), 'ig'));
			if (matches) {
				for (var k = 0; k < matches.length; k++) {
					var match = matches[k];
					if (unique[match]) {
						continue
					}
					unique[match] = 1;
					var n = "" + spade + cc;
					map[n] = match;
					source = source.replace(new RegExp(("(" + (encode(match)) + ")"), 'g'), n);
					cc++;
				}
			}
		}
	}
	var regex = new RegExp(("(" + spade + "[0-9+])"), 'g');
	var result = source.replace(regex, function (m) { return m.replace(m, tpl).replace(m, map[m]); });
	words = null;
	map = null;
	unique = null;
	return result
}

return highlight;

})));
//# sourceMappingURL=index.js.map
